//+------------------------------------------------------------------+
//|                       tro_spread_dots                            |
//|                                                                  | 
//|   Copyright  2016, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//| DO NOT DISTRIBUTE THIS CODE BY ANY MEANS - tell people to        |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2016, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
#property description "TRO - TheRumpledOne" 
#property description "DO NOT POST THIS ON OTHER FORUMS" 
#property description "www.kreslik.com is where TRO indicators can be found" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window 
#property indicator_buffers 4

// indicators parameters
 
extern bool   TURN_OFF           = false ;
extern bool   Show_PriceBox      = true ;
extern bool   Show_Targets       = false ;
extern bool   Show_PriceMark     = false ;
extern int    myBoxWidth         = 1;
extern bool   AskPriceBoxOnLeft  = false ; 
extern bool   BidPriceBoxOnLeft  = false ;   

extern int myStyle1  = 2 ;
extern int myStyle2  = 2 ;
extern int myStyle3  = 2 ;
extern int myStyle4  = 2 ;

extern int myWingDing1  = 171 ;
extern int myWingDing2  = 171 ;
extern int myWingDing3  = 170 ;
extern int myWingDing4  = 170 ;

extern color myColor1 = DimGray ;
extern color myColor2 = DimGray;
extern color myColor3 = clrSienna ;
extern color myColor4 = clrSienna; 
//---- buffers

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];
double DIFF; 

string tPIVOT0 = "PIVOT_0" ;
string tPIVOT1 = "PIVOT_1" ;
string tPIVOT2 = "PIVOT_2" ;
string tPIVOT3 = "PIVOT_3" ;
 
string tPIVOTA = "PIVOT_A" ;
string tPIVOTB = "PIVOT_B" ;
//+------------------------------------------------------------------+
int init()
{ 
   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);

   SetIndexArrow(0, myWingDing1); 
   SetIndexArrow(1, myWingDing2); 

   SetIndexStyle(0, DRAW_ARROW, myStyle1, 1, myColor1 );
   SetIndexStyle(1, DRAW_ARROW, myStyle2, 1, myColor2 );   

   if(Show_Targets)  
   { 
      SetIndexBuffer(2, P3Buffer);
      SetIndexBuffer(3, P4Buffer);
   
      SetIndexArrow(2, myWingDing3); 
      SetIndexArrow(3, myWingDing4); 
   
      SetIndexStyle(2, DRAW_ARROW, myStyle3, 1, myColor3 );
      SetIndexStyle(3, DRAW_ARROW, myStyle4, 1, myColor4 );   
   }
         
   for( int p=0;p<Bars;p++ ) 
   { 
      P1Buffer[p] = EMPTY_VALUE ;  
      P2Buffer[p] = EMPTY_VALUE ; 
      P3Buffer[p] = EMPTY_VALUE ;  
      P4Buffer[p] = EMPTY_VALUE ;  
   }

   deinit();
   
   return(0);
  }
 
//+------------------------------------------------------------------+
int deinit()
{

   ObjectDelete(tPIVOT0);
   ObjectDelete(tPIVOT1);
   ObjectDelete(tPIVOT2);
   ObjectDelete(tPIVOT3);
   ObjectDelete(tPIVOTA);
   ObjectDelete(tPIVOTB);
         
   TRO();
   
   return(0);
}
 
//+------------------------------------------------------------------+
int start()
{
   if( TURN_OFF ) { deinit(); return(0) ; } 

   for( int p=0;p< WindowBarsPerChart();p++ ) 
   { 
      P1Buffer[p] = EMPTY_VALUE ;  
      P2Buffer[p] = EMPTY_VALUE ; 
      P3Buffer[p] = EMPTY_VALUE ;  
      P4Buffer[p] = EMPTY_VALUE ; 
   }
		
   double X01 = Ask ;  
   double X02 = Bid ;  
   double X03 = 0 ;
   double X04 = 0 ;	
   double X05 = 0 ;	
   double X06 = 0 ;
	double X07 = 0 ;

   X01 = NormalizeDouble(X01, Digits) ;
   X02 = NormalizeDouble(X02, Digits) ; 

   DIFF = X01 - X02 ;
   
   X03 = X01 + DIFF  ;
   X04 = X02 - DIFF ;
   
	P1Buffer[0] = X01 ;
	P2Buffer[0] = X02 ;
	P3Buffer[0] = X03 ;
	P4Buffer[0] = X04 ;
	  
   if(Show_PriceBox)  
   { 
       
      if (ObjectFind(tPIVOT0) != 0)
      {
          ObjectCreate(tPIVOT0,OBJ_ARROW,0,Time[0],X01);
          if(AskPriceBoxOnLeft) {ObjectSet(tPIVOT0,OBJPROP_ARROWCODE,SYMBOL_LEFTPRICE);}
          else               {ObjectSet(tPIVOT0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);} 
          ObjectSet(tPIVOT0,OBJPROP_WIDTH,myBoxWidth);  
          ObjectSet(tPIVOT0,OBJPROP_COLOR,myColor1);  
      } 
      else
      {
         ObjectMove(tPIVOT0,0,Time[0],X01);
      }
      
      if (ObjectFind(tPIVOT1) != 0)
      {
          ObjectCreate(tPIVOT1,OBJ_ARROW,0,Time[0],X02);
          if(BidPriceBoxOnLeft) {ObjectSet(tPIVOT1,OBJPROP_ARROWCODE,SYMBOL_LEFTPRICE);}
          else               {ObjectSet(tPIVOT1,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);} 
          ObjectSet(tPIVOT1,OBJPROP_WIDTH,myBoxWidth);            
          ObjectSet(tPIVOT1,OBJPROP_COLOR,myColor2);  
      } 
      else
      {
         ObjectMove(tPIVOT1,0,Time[0],X02);
      }
   
      if(Show_Targets)  
      {  
         if (ObjectFind(tPIVOT2) != 0)
         {
             ObjectCreate(tPIVOT2,OBJ_ARROW,0,Time[0],X03);
             if(AskPriceBoxOnLeft) {ObjectSet(tPIVOT2,OBJPROP_ARROWCODE,SYMBOL_LEFTPRICE);}
             else               {ObjectSet(tPIVOT2,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);} 
             ObjectSet(tPIVOT2,OBJPROP_WIDTH,myBoxWidth);  
             ObjectSet(tPIVOT2,OBJPROP_COLOR,myColor3);  
         } 
         else
         {
            ObjectMove(tPIVOT2,0,Time[0],X03);
         }
           
           
         if (ObjectFind(tPIVOT3) != 0)
         {
             ObjectCreate(tPIVOT3,OBJ_ARROW,0,Time[0],X04);
             if(BidPriceBoxOnLeft) {ObjectSet(tPIVOT3,OBJPROP_ARROWCODE,SYMBOL_LEFTPRICE);}
             else               {ObjectSet(tPIVOT3,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);} 
             ObjectSet(tPIVOT3,OBJPROP_WIDTH,myBoxWidth);            
             ObjectSet(tPIVOT3,OBJPROP_COLOR,myColor4);  
         } 
         else
         {
            ObjectMove(tPIVOT3,0,Time[0],X04);
         }
      }  
 
     
   } // 
    
 
      if(Show_PriceMark)  
      {  
               ObjectDelete(tPIVOTA) ;
               ObjectCreate(tPIVOTA,OBJ_HLINE,0,0,Ask);
               ObjectSet(tPIVOTA,OBJPROP_COLOR,myColor1);
               ObjectSet(tPIVOTA,OBJPROP_HIDDEN,FALSE);
               ObjectSet(tPIVOTA,OBJPROP_STYLE,5);  
                     
               ObjectDelete(tPIVOTB) ;
               ObjectCreate(tPIVOTB,OBJ_HLINE,0,0,Bid);
               ObjectSet(tPIVOTB,OBJPROP_COLOR,myColor2);
               ObjectSet(tPIVOTB,OBJPROP_HIDDEN,FALSE);
               ObjectSet(tPIVOTB,OBJPROP_STYLE,5);       
      } 
    
   return(0);
}

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
